from django.shortcuts import render
from django.http import HttpResponse
from . models import Questions
from django.core.paginator import Paginator
from .forms import UploadFileForm
from django.http import HttpResponseRedirect
from .models import submission
from .models import cribs
from . newQuiz import readCSV
import csv
lst = []

answers = []
anslist = []
marksList=[]
negative=[]


def index(request):
    obj = Questions.objects.get_queryset().order_by('questionId')
    count = Questions.objects.all().count()
    """ paginator = Paginator(obj,1)
    try:
       page = int(request.GET.get('page','1'))  
    except:
        page =1
    try:
        questions = paginator.page(page)
    except Exception as e:

        questions=paginator.page(paginator.num_pages) """
    return render(request,'index.html',{'questions':obj,'count':count})


def result(request):
    answer=list() #contains user responses
    ans=list()
    for req in request.POST:
        ans.append(req)
    if(request.method =="POST"):
       
        quizId=request.POST['quizId']
        i=len(request.POST)
        j=2
        score=0
        while j<=i-2:
            #print(str(request.POST[ans[j-1]])+" :"+str(request.POST[ans[j]]))
            q=Questions.objects.all().filter(quizId=quizId,questionId=request.POST[ans[j-1]]).values()#fetch the given quiz answers marks and negative marking
            
            if(len(q)>=1):
                if(request.POST[ans[j]]==q[0]['answer']):
                    score+=q[0]['marks']
                elif(request.POST[ans[j]]!='NA'):
                    score-=q[0]['negative']
                answer.append(request.POST[ans[j]])
                t=submission(questionId=request.POST[ans[j-1]],option=request.POST[ans[j]],studentId=6969,quizId=quizId)#studentid hardcoded
                t.save()
            else:
                print(str(request.POST[ans[j-1]]))
            j+=2
            

        return HttpResponse(str(score))
                

    
    
def save_ans(request):
    ans = request.GET['ans']
    quizId=request.GET['quizId']
    questionId=request.GET['questionId']
    studentId=1# initialize here student id
    t=submission(questionId=questionId,option=ans,quizId=quizId,studentId=studentId)
    t.save()
    lst.append(ans)
    return HttpResponse('')

def save_cribs(request):
    crib=request.GET['cribs']
    studentId=1#set student id here 
    quizId=request.GET['quizId']
    questionId=request.GET['questionId']
    t=cribs(cribs=cribs,studentId=studentId,questionId=questionId,quizId=quizId)
    t.save()
    return HttpResponse('Suuuuuccess')  
    
def upload(request):
    return render(request,'upload.html')


def student(request):
    lst.clear()
    return render(request,'student.html')

def upload_file(request):
    uploaded=False
    temp1='test'
    form = UploadFileForm(request.POST, request.FILES)
    if request.method == 'POST' and form.is_valid():
        handle_uploaded_file(request.FILES['file'])
        uploaded=True
        return HttpResponse('success')
        
    else :
        return render(request,'upload.html',{temp1:'invalid File'})
    
    

def handle_uploaded_file(f):
    with open('name.csv', 'wb+') as destination:
        for chunk in f.chunks():
            destination.write(chunk)
    destination=open("name.csv","r") 
    rows=readCSV(destination)
    for row in rows:
        print(str(row))
        q=Questions(question=row[0],option1=row[1],option2=row[2],option3=row[3],option4=row[4],answer=row[5],type=row[6],marks=int(row[7]),negative=float(row[8]),explainations=row[9],quizId=row[10])
        q.save()


